/**
 * Copyright (c) 2011, Everit Kft.
 *
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301  USA
 */

function jqEscape(myid) {
	return myid.replace(/(:|\.)/g, '\\$1');
}

function containsInJavaArray(a, obj) {
	for ( var i = 0; i < a.length; i++) {
		if (a[i] === obj) {
			return true;
		}
	}
	return false;
}

function jqEscapeAndAddHashmark(myid) {
	return '#' + jqEscape(myid);
}

function getJsPattern(fPattern) {
	var ret = fPattern.replace(/yyyy/i, "%Y");
	ret = ret.replace(/MM/i, "%m");
	ret = ret.replace(/dd/i, "%d");
	ret = ret.replace(/yy/i, "%Y");
	ret = ret.replace(/HH/i, "%H");
	ret = ret.replace(/mm/i, "%M");
	ret = ret.replace(/ss/i, "%s");
	return ret;
}

function getJQueryPattern(fPattern) {
	var ret = fPattern.replace(/yyyy/i, "yy");
	ret = ret.replace(/MM/i, "mm");
	return ret;
}

function everitRunScripts(ajaxRequest, codeFunction) {
	if (ajaxRequest) {
		codeFunction();
	} else {
		$(document).ready(codeFunction);
	}
}

/* Checks periodically whether a function is available on an object. */
function waitForFunctionAvailable(elementObj, functionName, attempts, delay,
		onSuccessCallback, onFailCallback) {
	var functionType = typeof (elementObj[functionName]);
	if (functionType != 'undefined') {
		onSuccessCallback(); // Go do it.
		return true;
	} else {
		if (attempts == 0) {
			onFailCallback();
			return false;
		} else {
			// Put it back in the hopper.
			setTimeout(function() {
				waitForFunctionAvailable(elementObj, functionName, --attempts,
						delay, onSuccessCallback, onFailCallback);
			}, delay);
		}
	}
}

function contains(a, obj) {
	for ( var i = 0; i < a.length; i++) {
		if (a[i] === obj) {
			return true;
		}
	}
	return false;
}